"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
This Source Code Form is subject to the terms of the Mozilla Public
License, v. 2.0. If a copy of the MPL was not distributed with this
file, You can obtain one at https://mozilla.org/MPL/2.0/.
"""

import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.struct_pb2
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class ActionBuildStart(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACTION_ID_FIELD_NUMBER: builtins.int
    action_id: builtins.str
    def __init__(
        self,
        *,
        action_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["action_id", b"action_id"]) -> None: ...

global___ActionBuildStart = ActionBuildStart

@typing.final
class ActionBuildSuccess(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACTION_ID_FIELD_NUMBER: builtins.int
    action_id: builtins.str
    def __init__(
        self,
        *,
        action_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["action_id", b"action_id"]) -> None: ...

global___ActionBuildSuccess = ActionBuildSuccess

@typing.final
class ActionBuildCanceled(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ACTION_ID_FIELD_NUMBER: builtins.int
    action_id: builtins.str
    def __init__(
        self,
        *,
        action_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["action_id", b"action_id"]) -> None: ...

global___ActionBuildCanceled = ActionBuildCanceled

@typing.final
class ActionBuildError(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _ErrorCodes:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _ErrorCodesEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ActionBuildError._ErrorCodes.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        Undefined: ActionBuildError._ErrorCodes.ValueType  # 0
        ImageNameNotDefined: ActionBuildError._ErrorCodes.ValueType  # 1
        ActionTypeNotSupported: ActionBuildError._ErrorCodes.ValueType  # 2
        InternalRegistryConnection: ActionBuildError._ErrorCodes.ValueType  # 3
        ErrorWhileRunningProcess: ActionBuildError._ErrorCodes.ValueType  # 4
        RegisteringFunction: ActionBuildError._ErrorCodes.ValueType  # 5
        AnotherBuildIsInProgress: ActionBuildError._ErrorCodes.ValueType  # 6

    class ErrorCodes(_ErrorCodes, metaclass=_ErrorCodesEnumTypeWrapper): ...
    Undefined: ActionBuildError.ErrorCodes.ValueType  # 0
    ImageNameNotDefined: ActionBuildError.ErrorCodes.ValueType  # 1
    ActionTypeNotSupported: ActionBuildError.ErrorCodes.ValueType  # 2
    InternalRegistryConnection: ActionBuildError.ErrorCodes.ValueType  # 3
    ErrorWhileRunningProcess: ActionBuildError.ErrorCodes.ValueType  # 4
    RegisteringFunction: ActionBuildError.ErrorCodes.ValueType  # 5
    AnotherBuildIsInProgress: ActionBuildError.ErrorCodes.ValueType  # 6

    ACTION_ID_FIELD_NUMBER: builtins.int
    LOGS_FIELD_NUMBER: builtins.int
    CODE_FIELD_NUMBER: builtins.int
    action_id: builtins.str
    logs: builtins.str
    code: global___ActionBuildError.ErrorCodes.ValueType
    def __init__(
        self,
        *,
        action_id: builtins.str = ...,
        logs: builtins.str = ...,
        code: global___ActionBuildError.ErrorCodes.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["action_id", b"action_id", "code", b"code", "logs", b"logs"]) -> None: ...

global___ActionBuildError = ActionBuildError

@typing.final
class ActionReady(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Kind:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _KindEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ActionReady._Kind.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        NONE: ActionReady._Kind.ValueType  # 0
        SOURCE: ActionReady._Kind.ValueType  # 1
        PROCESSOR: ActionReady._Kind.ValueType  # 2
        PUBLISHER: ActionReady._Kind.ValueType  # 3

    class Kind(_Kind, metaclass=_KindEnumTypeWrapper): ...
    NONE: ActionReady.Kind.ValueType  # 0
    SOURCE: ActionReady.Kind.ValueType  # 1
    PROCESSOR: ActionReady.Kind.ValueType  # 2
    PUBLISHER: ActionReady.Kind.ValueType  # 3

    @typing.final
    class ActionResources(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        CPU_FIELD_NUMBER: builtins.int
        MEMORY_FIELD_NUMBER: builtins.int
        TIME_FIELD_NUMBER: builtins.int
        GPU_FIELD_NUMBER: builtins.int
        cpu: builtins.float
        memory: builtins.int
        time: builtins.float
        gpu: builtins.int
        def __init__(
            self,
            *,
            cpu: builtins.float | None = ...,
            memory: builtins.int | None = ...,
            time: builtins.float | None = ...,
            gpu: builtins.int | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["_cpu", b"_cpu", "_gpu", b"_gpu", "_memory", b"_memory", "_time", b"_time", "cpu", b"cpu", "gpu", b"gpu", "memory", b"memory", "time", b"time"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["_cpu", b"_cpu", "_gpu", b"_gpu", "_memory", b"_memory", "_time", b"_time", "cpu", b"cpu", "gpu", b"gpu", "memory", b"memory", "time", b"time"]) -> None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_cpu", b"_cpu"]) -> typing.Literal["cpu"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_gpu", b"_gpu"]) -> typing.Literal["gpu"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_memory", b"_memory"]) -> typing.Literal["memory"] | None: ...
        @typing.overload
        def WhichOneof(self, oneof_group: typing.Literal["_time", b"_time"]) -> typing.Literal["time"] | None: ...

    @typing.final
    class Logo(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        ACTION_LOGO_ID_FIELD_NUMBER: builtins.int
        ACTION_LOGO_NAME_FIELD_NUMBER: builtins.int
        ACTION_LOGO_EXTENSION_FIELD_NUMBER: builtins.int
        ACTION_LOGO_CONTENT_FIELD_NUMBER: builtins.int
        action_logo_id: builtins.str
        action_logo_name: builtins.str
        action_logo_extension: builtins.str
        action_logo_content: builtins.bytes
        def __init__(
            self,
            *,
            action_logo_id: builtins.str = ...,
            action_logo_name: builtins.str = ...,
            action_logo_extension: builtins.str = ...,
            action_logo_content: builtins.bytes = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["action_logo_content", b"action_logo_content", "action_logo_extension", b"action_logo_extension", "action_logo_id", b"action_logo_id", "action_logo_name", b"action_logo_name"]) -> None: ...

    @typing.final
    class ActionIO(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        class _Type:
            ValueType = typing.NewType("ValueType", builtins.int)
            V: typing_extensions.TypeAlias = ValueType

        class _TypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[ActionReady.ActionIO._Type.ValueType], builtins.type):
            DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
            NONE: ActionReady.ActionIO._Type.ValueType  # 0
            STRING: ActionReady.ActionIO._Type.ValueType  # 1
            LONGSTRING: ActionReady.ActionIO._Type.ValueType  # 2
            INTEGER: ActionReady.ActionIO._Type.ValueType  # 3
            FLOAT: ActionReady.ActionIO._Type.ValueType  # 4
            PASSWORD: ActionReady.ActionIO._Type.ValueType  # 5
            ENUM: ActionReady.ActionIO._Type.ValueType  # 6
            FILE: ActionReady.ActionIO._Type.ValueType  # 7
            DIRECTORY: ActionReady.ActionIO._Type.ValueType  # 8
            TABLE: ActionReady.ActionIO._Type.ValueType  # 9
            BYTES: ActionReady.ActionIO._Type.ValueType  # 10
            BOOLEAN: ActionReady.ActionIO._Type.ValueType  # 11

        class Type(_Type, metaclass=_TypeEnumTypeWrapper): ...
        NONE: ActionReady.ActionIO.Type.ValueType  # 0
        STRING: ActionReady.ActionIO.Type.ValueType  # 1
        LONGSTRING: ActionReady.ActionIO.Type.ValueType  # 2
        INTEGER: ActionReady.ActionIO.Type.ValueType  # 3
        FLOAT: ActionReady.ActionIO.Type.ValueType  # 4
        PASSWORD: ActionReady.ActionIO.Type.ValueType  # 5
        ENUM: ActionReady.ActionIO.Type.ValueType  # 6
        FILE: ActionReady.ActionIO.Type.ValueType  # 7
        DIRECTORY: ActionReady.ActionIO.Type.ValueType  # 8
        TABLE: ActionReady.ActionIO.Type.ValueType  # 9
        BYTES: ActionReady.ActionIO.Type.ValueType  # 10
        BOOLEAN: ActionReady.ActionIO.Type.ValueType  # 11

        ID_FIELD_NUMBER: builtins.int
        TECHNICAL_NAME_FIELD_NUMBER: builtins.int
        DISPLAY_NAME_FIELD_NUMBER: builtins.int
        HELP_FIELD_NUMBER: builtins.int
        TYPE_FIELD_NUMBER: builtins.int
        ENUM_VALUES_FIELD_NUMBER: builtins.int
        DEFAULT_VALUE_FIELD_NUMBER: builtins.int
        OPTIONAL_FIELD_NUMBER: builtins.int
        id: builtins.str
        technical_name: builtins.str
        display_name: builtins.str
        help: builtins.str
        type: global___ActionReady.ActionIO.Type.ValueType
        default_value: builtins.str
        optional: builtins.bool
        @property
        def enum_values(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
        def __init__(
            self,
            *,
            id: builtins.str = ...,
            technical_name: builtins.str = ...,
            display_name: builtins.str = ...,
            help: builtins.str = ...,
            type: global___ActionReady.ActionIO.Type.ValueType = ...,
            enum_values: collections.abc.Iterable[builtins.str] | None = ...,
            default_value: builtins.str = ...,
            optional: builtins.bool = ...,
        ) -> None: ...
        def ClearField(self, field_name: typing.Literal["default_value", b"default_value", "display_name", b"display_name", "enum_values", b"enum_values", "help", b"help", "id", b"id", "optional", b"optional", "technical_name", b"technical_name", "type", b"type"]) -> None: ...

    @typing.final
    class ActionAddonsEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> google.protobuf.struct_pb2.Struct: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: google.protobuf.struct_pb2.Struct | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing.Literal["key", b"key", "value", b"value"]) -> None: ...

    ACTION_ID_FIELD_NUMBER: builtins.int
    ACTION_NAME_FIELD_NUMBER: builtins.int
    ACTION_VERSION_FIELD_NUMBER: builtins.int
    ACTION_KIND_FIELD_NUMBER: builtins.int
    ACTION_DESCRIPTION_FIELD_NUMBER: builtins.int
    ACTION_DYNAMIC_OUTPUTS_FIELD_NUMBER: builtins.int
    ACTION_INPUTS_FIELD_NUMBER: builtins.int
    ACTION_OUTPUTS_FIELD_NUMBER: builtins.int
    ACTION_OWNER_ID_FIELD_NUMBER: builtins.int
    ACTION_LOGO_FIELD_NUMBER: builtins.int
    ACTION_TECHNICAL_NAME_FIELD_NUMBER: builtins.int
    ACTION_BUILD_DATE_FIELD_NUMBER: builtins.int
    ACTION_CATEGORIES_FIELD_NUMBER: builtins.int
    ACTION_PROJECT_ID_FIELD_NUMBER: builtins.int
    ACTION_ADDONS_FIELD_NUMBER: builtins.int
    ACTION_RESOURCES_FIELD_NUMBER: builtins.int
    LOCKFILE_FIELD_NUMBER: builtins.int
    action_id: builtins.str
    action_name: builtins.str
    action_version: builtins.str
    action_kind: global___ActionReady.Kind.ValueType
    action_description: builtins.str
    action_dynamic_outputs: builtins.bool
    action_owner_id: builtins.str
    action_technical_name: builtins.str
    action_project_id: builtins.str
    lockfile: builtins.bytes
    @property
    def action_inputs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ActionReady.ActionIO]: ...
    @property
    def action_outputs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___ActionReady.ActionIO]: ...
    @property
    def action_logo(self) -> global___ActionReady.Logo: ...
    @property
    def action_build_date(self) -> google.protobuf.timestamp_pb2.Timestamp: ...
    @property
    def action_categories(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]: ...
    @property
    def action_addons(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, google.protobuf.struct_pb2.Struct]: ...
    @property
    def action_resources(self) -> global___ActionReady.ActionResources: ...
    def __init__(
        self,
        *,
        action_id: builtins.str = ...,
        action_name: builtins.str = ...,
        action_version: builtins.str = ...,
        action_kind: global___ActionReady.Kind.ValueType = ...,
        action_description: builtins.str = ...,
        action_dynamic_outputs: builtins.bool = ...,
        action_inputs: collections.abc.Iterable[global___ActionReady.ActionIO] | None = ...,
        action_outputs: collections.abc.Iterable[global___ActionReady.ActionIO] | None = ...,
        action_owner_id: builtins.str = ...,
        action_logo: global___ActionReady.Logo | None = ...,
        action_technical_name: builtins.str = ...,
        action_build_date: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        action_categories: collections.abc.Iterable[builtins.str] | None = ...,
        action_project_id: builtins.str = ...,
        action_addons: collections.abc.Mapping[builtins.str, google.protobuf.struct_pb2.Struct] | None = ...,
        action_resources: global___ActionReady.ActionResources | None = ...,
        lockfile: builtins.bytes = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["_action_resources", b"_action_resources", "action_build_date", b"action_build_date", "action_logo", b"action_logo", "action_resources", b"action_resources"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["_action_resources", b"_action_resources", "action_addons", b"action_addons", "action_build_date", b"action_build_date", "action_categories", b"action_categories", "action_description", b"action_description", "action_dynamic_outputs", b"action_dynamic_outputs", "action_id", b"action_id", "action_inputs", b"action_inputs", "action_kind", b"action_kind", "action_logo", b"action_logo", "action_name", b"action_name", "action_outputs", b"action_outputs", "action_owner_id", b"action_owner_id", "action_project_id", b"action_project_id", "action_resources", b"action_resources", "action_technical_name", b"action_technical_name", "action_version", b"action_version", "lockfile", b"lockfile"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["_action_resources", b"_action_resources"]) -> typing.Literal["action_resources"] | None: ...

global___ActionReady = ActionReady

@typing.final
class NoActionBuild(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___NoActionBuild = NoActionBuild
